package Alunos;



/**
 * The test class Teste.
 *
 * @author  (your name)
 * @version (a version number or a date)
 */
public class Teste extends junit.framework.TestCase
{
    /**
     * Default constructor for test class Teste
     */
    public Teste()
    {
    }

    /**
     * Sets up the test fixture.
     *
     * Called before every test case method.
     */
    protected void setUp()
    {
    }

    /**
     * Tears down the test fixture.
     *
     * Called after every test case method.
     */
    protected void tearDown()
    {
    }

    public void testAluno()
    {
//criando os objetos
RelaQueue queue = new RelaQueue();
Professor prof = new Professor(queue);
AlunoEsforcado aluno1 = new AlunoEsforcado("John Smith", queue);
AlunoEsforcado aluno2 = new AlunoEsforcado("Mark Smith", queue);
AlunoSafoPreguicoso aluno3 = new AlunoSafoPreguicoso("Joseph Smith", queue);
AlunoSafoPreguicoso aluno4 = new AlunoSafoPreguicoso("Robert Smith", queue);
 
//teste de alunoesforcado
assertEquals(0.5, aluno1.getInteligencia(), 0.01);
assertEquals(1, aluno1.getDedicacao(), 0.01);
 
//teste de alunosafo
assertEquals(1.0, aluno3.getInteligencia(), 0.01);
assertTrue(aluno3.getDedicacao() != aluno3.getDedicacao()); //deve ser randomica
assertTrue(aluno3.getDedicacao() < 0.5);
 
//alunos comecam a fazer os relas
aluno1.fazEEntregaRelatorio();
 
//roubamos o relatório do primeiro aluno para investigá-lo
Relatorio rela1 = queue.dequeue();
assertEquals(aluno1, rela1.getAluno());
assertTrue(rela1.getAluno().getNome().equals("John Smith"));
assertTrue(rela1.getQualidade() < 0.9);
assertTrue(rela1.getQualidade() > 0.8);
assertTrue(rela1.getOriginalidade() < 0.7);
assertTrue(rela1.getOriginalidade() > 0.6);
 
//os outros continuam a fazer os relas
aluno2.fazEEntregaRelatorio();
aluno3.fazEEntregaRelatorio();
aluno4.fazEEntregaRelatorio();
 
//deve exibir a coreção dos relas dos aluno2, aluno3, e aluno4, nesta ordem
//pois "roubamos" o relatório do aluno1
prof.corrigirRelatorios();

    }
    
    public void testUsaInterfaceComoTipo()
    {
      RelaQueue queue = new RelaQueue();
      AlunoSafoPreguicoso aluno1 = new AlunoSafoPreguicoso("John Smith", queue);
      AlunoEsforcado aluno2 = new AlunoEsforcado("Mark Smith", queue);
      Cachorro pet = new Cachorro();
      this.dizSeEhInteligente(aluno1);
      this.dizSeEhInteligente(aluno2);
      this.dizSeEhInteligente(pet);
    }    

    private void dizSeEhInteligente(ComComportamento obj) {  
        if (obj.getInteligencia() > 0.5) 
            System.out.println ("Isto é um gênio!"); 
        else
            System.out.println ("Isto é burro!");
    }
}

