package Alunos;

import java.util.Random;
 
public class AlunoSafoPreguicoso extends Aluno    
{
 
    private float inteligencia = 1;
 
    //construtor da classe
    //chama o construtor da super classe com os mesmos parâmetros
    public AlunoSafoPreguicoso(String nome, RelaQueue queue)
    {
        super(nome, queue);
    }
 
    //retorna a inteligencia a partir da propriedade
    public float getInteligencia()
    {
        return this.inteligencia;
    }
 
    //retorna a dedicação do aluno a partir de um valor pseudo-aleatório
    public float getDedicacao()
    {
        Random generator = new Random();
        float r = generator.nextFloat();
        return r * 0.5f;
    }
 
}
